> ## Documentation Index
> Fetch the complete documentation index at: https://docs.engine.usesophic.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a file

> Create a file from a signed upload. **Please use the `id` that was returned when the signed upload was requested.**



## OpenAPI

````yaml /openapi.json post /files
openapi: 3.1.0
info:
  title: Sophic Engine API
  version: 0.1.0
servers:
  - url: https://api.engine.usesophic.com
security: []
tags:
  - description: Retrieve accounts, statements, and account documents.
    name: accounts
    x-group: Accounts
  - description: Read the audit trail of platform activity.
    name: activity
    x-group: Activity
  - description: Obtain OAuth access tokens for the Engine API.
    name: auth
    x-group: Authentication
  - description: Inspect the authenticated user or service actor.
    name: identity
    x-group: Identity
  - description: Retrieve fee schedules and billing information.
    name: billing
    x-group: Billing
  - description: Browse instruments and tradable products.
    name: catalog
    x-group: Catalog
  - description: Track onboarding applications through completion.
    name: onboarding
    x-group: Onboarding
  - description: Manage customer records and related person data.
    name: customers
    x-group: Customers
  - description: List platform events and inspect individual occurrences.
    name: events
    x-group: Events
  - description: Read positions, transactions, and account holdings.
    name: holdings
    x-group: Holdings
  - description: Retrieve legal agreements and required disclosures.
    name: legal-documents
    x-group: Legal Documents
  - description: Access prices and market data for instruments.
    name: market-data
    x-group: Market Data
  - description: Manage deposits, withdrawals, and funding accounts.
    name: payments
    x-group: Payments
  - description: Retrieve returns, earnings, and performance metrics.
    name: performance
    x-group: Performance
  - description: Place and manage orders, quotes, and trades.
    name: trading
    x-group: Trading
  - description: Read position and account valuations over time.
    name: valuation
    x-group: Valuation
  - description: Configure webhook endpoints and inspect deliveries.
    name: webhooks
    x-group: Webhooks
  - description: Upload files and retrieve stored documents.
    name: files
    x-group: Files
paths:
  /files:
    post:
      tags:
        - files
      summary: Create a file
      description: >-
        Create a file from a signed upload. **Please use the `id` that was
        returned when the signed upload was requested.**
      operationId: create_file_from_signed_upload_files_post
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateFileFromSignedUploadRequest'
        required: true
      responses:
        '201':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/File'
          description: Created
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
          description: Bad Request
      security:
        - HTTPBearer: []
components:
  schemas:
    CreateFileFromSignedUploadRequest:
      properties:
        signed_upload:
          description: ID of the signed upload to create the file from.
          title: Signed Upload
          type: string
      required:
        - signed_upload
      title: CreateFileFromSignedUploadRequest
      type: object
    File:
      properties:
        content_type:
          description: MIME type of the uploaded file.
          title: Content Type
          type: string
        created_at:
          description: >-
            The timestamp (in
            [ISO-8601](https://www.iso.org/iso-8601-date-and-time-format.html)
            format) of when the resource was created.
          format: date-time
          title: Created At
          type: string
        filename:
          description: Name of the uploaded file.
          title: Filename
          type: string
        id:
          description: Unique resource identifier.
          title: Id
          type: string
        modified_at:
          description: >-
            The timestamp (in
            [ISO-8601](https://www.iso.org/iso-8601-date-and-time-format.html)
            format) of when the resource was last modified.
          format: date-time
          title: Modified At
          type: string
        purpose:
          description: Purpose of the uploaded file.
          enum:
            - verification_evidence
            - legal_document
            - welcome_letter
            - order_confirmation
            - fee_statement
            - account_statement
          title: Purpose
          type: string
        signed_upload:
          anyOf:
            - type: string
            - type: 'null'
          description: ID of the signed upload that created the file.
          title: Signed Upload
      required:
        - created_at
        - modified_at
        - id
        - filename
        - content_type
        - purpose
        - signed_upload
      title: File
      type: object
    Error:
      properties:
        code:
          description: A machine-readable error code.
          title: Code
          type: string
        context:
          additionalProperties:
            anyOf:
              - type: string
              - type: integer
          description: An optional object for adding extra context to the error.
          title: Context
          type: object
          x-remove-null-from-type-union: true
        detail:
          description: A human-readable description of the error.
          title: Detail
          type: string
        docs:
          description: A URL to documentation about this error code.
          title: Docs
          type: string
          x-remove-null-from-type-union: true
        params:
          description: An optional list of params that failed validation.
          items:
            $ref: '#/components/schemas/InvalidParam'
          title: Params
          type: array
          x-remove-null-from-type-union: true
      required:
        - detail
        - code
      title: Error
      type: object
    InvalidParam:
      properties:
        code:
          description: A machine-readable error code.
          title: Code
          type: string
        detail:
          description: Human-readable detail for error.
          title: Detail
          type: string
        path:
          description: Path to the field name (or index if a list) that errored.
          items:
            anyOf:
              - type: integer
              - type: string
          title: Path
          type: array
      required:
        - path
        - detail
        - code
      title: InvalidParam
      type: object
  securitySchemes:
    HTTPBearer:
      scheme: bearer
      type: http

````